Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.exist.xquery
Class BindingExpression

    java.lang.Object
      org.exist.xquery.AbstractExpression
          org.exist.xquery.BindingExpression

All Implemented Interfaces:
  Expression

Direct Known Subclasses:
  ForExpr, LetExpr, QuantifiedExpression

public abstract class BindingExpression
extends AbstractExpression

Abstract superclass for the variable binding expressions "for" and "let".

Author:
  Wolfgang Meier

Field Summary

Fields inherited from interface org.exist.xquery.Expression
`DOT_TEST, EXPRESSION_ID_INVALID, IGNORE_CONTEXT, IN_PREDICATE, IN_UPDATE, IN_WHERE_CLAUSE, NO_CONTEXT_ID, SINGLE_STEP_EXECUTION`

Constructor Summary
`BindingExpression(XQueryContext context)`

Method Summary
`void` | `analyze(AnalyzeContextInfo contextInfo)` Statically analyze the expression and its subexpressions.
`abstract void` | `analyze(AnalyzeContextInfo contextInfo, OrderSpec[] orderBy)`
`Sequence` | `eval(Sequence contextSequence, Item contextItem)` Evaluate the expression represented by this object.
`abstract Sequence` | `eval(Sequence contextSequence, Item contextItem, Sequence resultSequence)`
`DocumentSet` | `preselect(DocumentSet in_docs)`
`void` | `resetState()` Called to inform an expression that it should reset to its initial state.
`int` | `returnsType()` The static return type of the expression.
`void` | `setInputSequence(Expression sequence)`
`void` | `setOrderSpecs(OrderSpec[] specs)`
`void` | `setReturnExpression(Expression expr)`
`void` | `setSequenceType(SequenceType type)` Set the sequence type of the variable (as specified in the "as" clause).
`void` | `setVariable(java.lang.String qname)`
`void` | `setWhereExpression(Expression expr)`

Methods inherited from class org.exist.xquery.AbstractExpression
`accept, eval, getASTNode, getCardinality, getContextDocSet, getContextId, getDependencies, getExpressionId, setASTNode, setContextDocSet, setPrimaryAxis`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.exist.xquery.Expression
`dump`

Constructor Detail

### BindingExpression

    public BindingExpression(XQueryContext context)

Method Detail

### setVariable

    public void setVariable(java.lang.String qname)

### setSequenceType

    public void setSequenceType(SequenceType type)

  Set the sequence type of the variable (as specified in the "as" clause).

  Parameters:
    `type` -

### setInputSequence

    public void setInputSequence(Expression sequence)

### setReturnExpression

    public void setReturnExpression(Expression expr)

### setWhereExpression

    public void setWhereExpression(Expression expr)

### setOrderSpecs

    public void setOrderSpecs(OrderSpec[] specs)

### analyze

    public void analyze(AnalyzeContextInfo contextInfo)
                 throws XPathException

  Description copied from interface: `Expression`
  Statically analyze the expression and its subexpressions. During the static analysis phase, the query engine can detect unknown variables and some type errors.

  Throws:
    `XPathException`

### analyze

    public abstract void analyze(AnalyzeContextInfo contextInfo,
                                 OrderSpec[] orderBy)
                          throws XPathException

  Throws:
    `XPathException`

### eval

    public Sequence eval(Sequence contextSequence,
                         Item contextItem)
                  throws XPathException

  Description copied from interface: `Expression`
  Evaluate the expression represented by this object. Depending on the context in which this expression is executed, either the context sequence, the context item or both of them may be set. An implementing class should know how to handle this. The general contract is as follows: if the `Dependency.CONTEXT_ITEM` bit is set in the bit field returned by `Expression.getDependencies()`, the eval method will be called once for every item in the context sequence. The contextItem parameter will be set to the current item. Otherwise, the eval method will only be called once for the whole context sequence and contextItem will be null. eXist tries to process the entire context set in one, single step whenever possible. Thus, most classes only expect context to contain a list of nodes which represents the current context of the expression. The position() function in XPath is an example for an expression, which requires both, context sequence and context item to be set. The context sequence might be a node set, a sequence of atomic values or a single node or atomic value.

  Specified by:
    `eval` in interface `Expression`
  Specified by:
    `eval` in class `AbstractExpression`
  Throws:
    `XPathException`

### eval

    public abstract Sequence eval(Sequence contextSequence,
                                  Item contextItem,
                                  Sequence resultSequence)
                           throws XPathException

  Throws:
    `XPathException`

### preselect

    public DocumentSet preselect(DocumentSet in_docs)
                          throws XPathException

  Throws:
    `XPathException`

### returnsType

    public int returnsType()

  Description copied from interface: `Expression`
  The static return type of the expression. This method should return one of the type constants defined in class `Type`. If the return type cannot be determined statically, return Type.ITEM.

  Specified by:
    `returnsType` in interface `Expression`
  Specified by:
    `returnsType` in class `AbstractExpression`

### resetState

    public void resetState()

  Description copied from interface: `Expression`
  Called to inform an expression that it should reset to its initial state. All cached data in the expression object should be dropped. For example, the document() function calls this method whenever the input document set has changed.

  Specified by:
    `resetState` in interface `Expression`
  Overrides:
    `resetState` in class `AbstractExpression`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Wolfgang Meier. All rights reserved.